datablock AudioProfile(tierfragGrenadeExplosionSound)
{
   filename    = "add-ons/Gamemode_DM_Mesa/explosives/frag_blast.wav";
   description = AudioDefault3d;
   preload = false;
};

datablock AudioProfile(tierfragGrenadeBounceSound)
{
   filename    = "add-ons/Gamemode_DM_Mesa/explosives/frag_bounce.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(tierfragGrenadeTossSound)
{
   filename    = "add-ons/Gamemode_DM_Mesa/explosives/grenade_toss.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock ParticleData(tierfraggrenadeTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 300;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
	colors[0]	= "0.1 0.1 0.1 0";
	colors[1]	= "0.1 0.1 0.1 0.20";
	colors[2]	= "0.1 0.1 0.1 0";
	sizes[0]	= 0.6;
	sizes[1]	= 0.4;
	sizes[2]	= 0.1;
	times[0]	= 0.0;
	times[1]	= 0.1;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(tierfraggrenadeTrailEmitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 2;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;

   particles = tierfraggrenadeTrailParticle;
};

datablock ParticleData(tierfragGrenadeExplosionParticle)
{
	dragCoefficient		= 1.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 800;
	lifetimeVarianceMS	= 500;
	spinSpeed		= 5.0;
	spinRandomMin		= -5.0;
	spinRandomMax		= 5.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= "~/data/particles/cloud";

	// Interpolation variables
   colors[0]     = "0.9 0.5 0.0 0.6";
   colors[1]     = "0.1 0.05 0.025 0.3";
   colors[2]     = "0.1 0.05 0.025 0.1";

	sizes[0]	= 15.0;
	sizes[1]	= 10.0;
   sizes[2]	= 10.5;

	times[0]	= 0.0;
	times[1]	= 0.28;
   times[2]	= 1.0;
};

datablock ParticleEmitterData(tierfragGrenadeExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   lifeTimeMS	   = 21;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 1.0;
   thetaMin         = 0;
   thetaMax         = 0;
   phiReferenceVel  = 0;
   phiVariance      = 90;
   overrideAdvance = false;
   particles = "tierfragGrenadeExplosionParticle";
};

datablock ParticleData(tierfragGrenadeExplosionParticle2)
{
	dragCoefficient		= 1.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= -0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 2000;
	lifetimeVarianceMS	= 1990;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
   colors[0]     = "1 0.5 0.0 1";
   colors[1]     = "0.9 0.4 0.0 0.8";
   colors[2]     = "1 1 1 0.0";

	sizes[0]	= 0.2;
	sizes[1]	= 0.2;
   sizes[2]	= 0.2;

	times[0]	= 0.0;
	times[1]	= 0.1;
   times[2]	= 1.0;
};

datablock ParticleEmitterData(tierfragGrenadeExplosionEmitter2)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   lifetimeMS       = 120;
   ejectionVelocity = 12;
   velocityVariance = 12.0;
   ejectionOffset   = 1.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "tierfragGrenadeExplosionParticle2";
};


datablock ParticleData(tierfragGrenadeExplosionRingParticle)
{
   dragCoefficient      = 8;
   gravityCoefficient   = -0.5;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 100;
   lifetimeVarianceMS   = 10;
   textureName          = "base/data/particles/star1";
   spinSpeed        = 10.0;
   spinRandomMin        = -500.0;
   spinRandomMax        = 500.0;
   colors[0]     = "1.0 1.0 0.6 1";
   colors[1]     = "1.0 1.0 0.6 1";
   sizes[0]      = 19;
   sizes[1]      = 22;

   useInvAlpha = false;
};

datablock ParticleEmitterData(tierfragGrenadeExplosionRingEmitter)
{
   lifeTimeMS = 50;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "tierfragGrenadeExplosionRingParticle";
};

datablock ParticleData(tierFragGrenadeExplosionRing2Particle)
{
	dragCoefficient      = 4;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 1350;
	lifetimeVarianceMS   = 135;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 25.0;
	spinRandomMin		= -25.0;
	spinRandomMax		= 25.0;
   colors[0]     = "0.1 0.05 0.025 0.3";
   colors[1]     = "0.1 0.05 0.025 0.0";
	sizes[0]      = 8;
	sizes[1]      = 6;

	useInvAlpha = false;
};
datablock ParticleEmitterData(tierFragGrenadeExplosionRing2Emitter)
{
	lifeTimeMS = 90;

   ejectionPeriodMS = 6;
   periodVarianceMS = 0;
   ejectionVelocity = 22;
   velocityVariance = 1.0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "tierFragGrenadeExplosionRing2Particle";
};
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

datablock ExplosionData(tierfragGrenadeExplosion)
{
   explosionShape = "Add-Ons/Weapon_Rocket Launcher/explosionSphere1.dts";
   lifeTimeMS = 150;

   soundProfile = tierfragGrenadeExplosionSound;

   emitter[0] = tierfragGrenadeExplosionRingEmitter;
   emitter[1] = tierfragGrenadeExplosionEmitter;
   emitter[2] = tierFragGrenadeExplosionRing2Emitter;
   //emitter[1] = "";
   //emitter[2] = "";
   //emitter[0] = "";

   particleEmitter = tierfragGrenadeExplosionEmitter2;
   particleDensity = 90;
//   particleDensity = 0;
   particleRadius = 1.0;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 0;
   lightStartColor = "0.45 0.3 0.1";
   lightEndColor = "0 0 0";

   //impulse
   impulseRadius = 8;
   impulseForce = 5600;

   damageRadius = 6;
   radiusDamage = 120;

	uiName = "Grenade Explosion";
};

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

AddDamageType("TfraggrenadeDirect",   '<bitmap:add-ons/Gamemode_DM_Mesa/explosives/ci_conc_grenade> %1',    '%2 <bitmap:add-ons/Gamemode_DM_Mesa/explosives/ci_conc_grenade> %1',1,1);

//projectile
datablock ProjectileData(tierfragGrenadeProjectile)
{
   projectileShapeName = "add-ons/Gamemode_DM_Mesa/explosives/frag_grenade.dts";
   directDamage        = 20;
   directDamageType  = $DamageType::TfragGrenadeDirect;
   radiusDamageType  = $DamageType::TfragGrenadeDirect;
   impactImpulse	   = 1200;
   verticalImpulse	   = 1200;
   explosion           = tierfragGrenadeExplosion;
   particleEmitter     = tierfragGrenadeTrailEmitter;

   muzzleVelocity      = 45;
   velInheritFactor    = 0;
   explodeOnPlayerImpact = true;
   explodeOnDeath        = true;

   brickExplosionRadius = 5;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 34;
   brickExplosionMaxVolume = 45;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 90;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   armingDelay         = 3990;
   lifetime            = 4000;
   fadeDelay           = 3990;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.1;
   isBallistic         = true;
   gravityMod = 1.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Conc' Grenade";
};

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//////////
// item //
//////////
datablock ItemData(tierfragGrenadeItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "add-ons/Gamemode_DM_Mesa/explosives/frag_grenade.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Conc' Grenade";
	iconName = "add-ons/Gamemode_DM_Mesa/explosives/icon_conc_grenade";
	l4ditemtype = "grenade";

	 // Dynamic properties defined by the scripts
	image = tierfragGrenadeImage;
	canDrop = true;
};

datablock ShapeBaseImageData(tierfragGrenadeImage)
{
   // Basic Item properties
   shapeFile = "add-ons/Gamemode_DM_Mesa/explosives/frag_grenade.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = tierfragGrenadeItem;
   ammo = " ";
   projectile = tierfragGrenadeProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   colorShiftColor = "0.400 0.196 0 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state


	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.01;
	stateTransitionOnTimeout[0]	= "Ready";
	stateScript[0]                  = "onActivate";

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Tick";
	stateScript[1]                  = "onReady";
	stateTransitionOnTimeout[1]	= "Ready";
	stateWaitForTimeout[1]		= false;
	stateTimeoutValue[1]		= 0.4;
	stateAllowImageChange[1]	= true;

	stateName[2]			= "Tick";
	stateTransitionOnTimeout[2]	= "Charge";
	stateAllowImageChange[2]	= false;
	stateSound[2]				= block_moveBrick_Sound;
	stateScript[2]                  = "onTick";
	stateTimeoutValue[2]		= 0.05;

	stateName[3]			= "SKIPC";
	stateTransitionOnTriggerDown[3]	= "Charge";
	stateAllowImageChange[3]	= false;

	stateName[4]                    = "Charge";
	stateTransitionOnTimeout[4]	= "Armed";
	stateTimeoutValue[4]            = 0.1;
	stateWaitForTimeout[4]		= false;
	stateScript[4]                  = "onCharge";
	stateAllowImageChange[4]        = true;

	stateName[5]			= "AbortCharge";
	stateTransitionOnTimeout[5]	= "Ready";
	stateTimeoutValue[5]		= 0.1;
	stateWaitForTimeout[5]		= true;
	stateScript[5]			= "onAbortCharge";
	stateAllowImageChange[5]	= false;

	stateName[6]			= "Armed";
	stateScript[6]			= "onArmed";
	stateTransitionOnTriggerUp[6]	= "Fire";
	stateWaitForTimeout[6]		= false;
	stateTimeoutValue[6]		= 0.4;
	stateAllowImageChange[6]	= true;

	stateName[7]			= "Fire";
	stateTransitionOnTimeout[7]	= "Activate";
	stateTimeoutValue[7]		= 0.5;
	stateFire[7]			= true;
	stateSound[7]				= tierfraggrenadetossSound;
	stateSequence[7]		= "fire";
	stateScript[7]			= "onFire";
	stateWaitForTimeout[7]		= true;
	stateAllowImageChange[7]	= false;

	stateName[8]					= "Done";
	stateScript[8]					= "onDone";
	stateTransitionOnTimeout[8]	= "Activate";
	stateTimeoutValue[8]		= 0.5;
};

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function tierfragGrenadeImage::onArmed(%this, %obj, %slot)
{
            	commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:fff000>Conc' Grenades <font:impact:34>\c6 " @ %obj.client.quantity["fragNades"] @ "", 1, 2, 3, 4);

	%obj.playthread(2, spearready);
	%obj.lasttierfragslot = %obj.currTool;
}

function tierfragGrenadeImage::onAbortCharge(%this, %obj, %slot)
{
	%obj.playthread(2, root);
}

function tierfragGrenadeImage::onFire(%this, %obj, %slot)
{
    	if(%obj.client.quantity["fragNades"] >= 1)
	{
	Parent::OnFire(%this, %obj, %slot);
	%obj.client.quantity["fragnades"] -= 1;
	}

    	if(%obj.client.quantity["fragNades"] <= 0)
	{
	%obj.unMountImage(0);
	}

	%obj.playThread(2, spearthrow);
            serverPlay3D(tierfraggrenadetossSound,%obj.getPosition());
}

function tierFragGrenadeImage::onReady(%this, %obj, %slot)
{
            	commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:fff000>Conc' Grenades <font:impact:34>\c6 " @ %obj.client.quantity["fragNades"] @ "", 1, 2, 3, 4);
    	if(%obj.client.quantity["fragNades"] <= 0)
	{
	%obj.unMountImage(0);
	%obj.playThread(2, root);
	%obj.playThread(1, root);
	%obj.playThread(0, root);
	}
}

function tierFragGrenadeImage::onTick(%this, %obj, %slot)
{
            	commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:fff000>Conc' Grenades <font:impact:34>\c6 " @ %obj.client.quantity["fragNades"] @ "", 1, 2, 3, 4);

	%obj.playThread(2, shiftLeft);
    	if(%obj.client.quantity["stickNades"] <= 0)
	{
	%obj.unMountImage(0);
	%obj.playThread(2, root);
	%obj.playThread(1, root);
	%obj.playThread(0, root);
	}
}

function tierFragGrenadeImage::onCharge(%this, %obj, %slot)
{
    	if(%obj.client.quantity["fragNades"] <= 0)
	{
	%obj.unMountImage(0);
	%obj.playThread(2, root);
	%obj.playThread(1, root);
	%obj.playThread(0, root);
	}
}

function tierfraggrenadeProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	serverPlay3D(tierfraggrenadeBounceSound,%obj.getTransform());
}

function tierfragGrenadeImage::onDone(%this,%obj,%slot)
{
	%obj.unMountImage(%slot);
}
